/* Copyright 2006 Jetro Lauha - http://iki.fi/jetro/
 *
 * $Id: TitleState.h,v 1.2 2006-04-30 16:07:42 tonic Exp $
 * $Revision: 1.2 $
 */

#ifndef TITLESTATE_H_INCL
#define TITLESTATE_H_INCL


class TitleState : public State, public UIEventListener
{
public:

    TitleState();
    virtual ~TitleState();

    // From State:

    virtual BOOL init();
    virtual void deinit();

    virtual BOOL update(UINT32 time);
    virtual void render(SDL_Surface *screen);

    virtual void onActivate(UINT32 time);

    virtual void onKeyDown(const SDLKey &key);
    virtual void onMouseDown(const SDL_MouseButtonEvent &event);
    virtual void onMouseUp(const SDL_MouseButtonEvent &event);
    virtual void onMouseMotion(const SDL_MouseMotionEvent &event);

    // From UIEventListener:

    virtual void onAction(UIComponent *component);

protected:

    void gameStart();

    UINT32 mTime;
    UI mUI;

    UIButton *mPlayButton;
    UIButton *mExitButton;
    UILabel *mScoreLabel;

    UIImage *mButtonUpImage;
    UIImage *mButtonDownImage;

    UIImage *mBackgroundImage;
};


#endif // !TITLESTATE_H_INCL
