/* Copyright 2006 Jetro Lauha - http://iki.fi/jetro/
 *
 * $Id: sound.h,v 1.2 2006-04-30 22:11:53 tonic Exp $
 * $Revision: 1.2 $
 */

#ifndef SOUND_H_INCLUDED
#define SOUND_H_INCLUDED


#define CHANNELS            16
#define BASE_SND_CHANNEL    (CHANNELS - 1)

enum SOUND_TYPE_ENUM
{
    SOUND_ACTIVATE = 0,
    SOUND_BASE,
    SOUND_BRAKE,
    SOUND_BUTTON,
    SOUND_DETACH,
    SOUND_GRAB,
    SOUND_LEVELDONE,
    SOUND_STARTLEVEL,
    SOUND_TARGET,
    SOUND_TYPE_COUNT
};

enum MUSIC_ORDER_ENUM
{
    MUSIC_BASE      = 0
};


extern void initSound();
extern void deinitSound();
extern int playSoundEffect(int type, int forceChannel = -1);
extern void stopSoundEffect(int channel);
extern void stopAllSoundEffects();
extern void setSoundChannelVolume(int channel, int volume);
extern void setSoundChannelFrequency(int channel, int freq);

extern void setSound(BOOL enabled);
extern void setMusic(BOOL enabled, INT order);

extern BOOL getSoundEnabled();
extern BOOL getMusicEnabled();

extern void setMusicVolume(float volume);


#endif // !SOUND_H_INCLUDED
